#include <cstdio>

#include <qblib/stream.hh>

class QbFPstream: public PrintStreamBase
{
public:
    QbFPstream(int fd) : PrintStreamBase(fdopen(fd, "w")) { }
    
    virtual void DoSPC(int count) { }
    virtual void DoTAB(int count) { }
    virtual void DoNextTAB() { }
    virtual void DoCRLF() { *this << std::endl; }
};

class QbFIstream: public InputStreamBase
{
public:
    QbFIstream(int fd) : InputStreamBase(fdopen(fd, "r")) { }
    
    virtual void ReadLine(BAS_STR& target)
    {
    }

    virtual void InputTo(BAS_INT& target)
    {
    }

    virtual void InputTo(BAS_DBL& target)
    {
    }

    virtual void InputTo(BAS_STR& target)
    {
    }

    virtual void InputTo(BAS_SGN& target)
    {
    }

    virtual void InputTo(BAS_LNG& target)
    {
    }

    virtual bool Satisfied()
    {
    }

    virtual BAS_STR Input_N(unsigned n)
    {
    }

    virtual BAS_STR Inkey_S()
    {
    }
};


PrintStreamBase& GET_STDOUT()
{
    static QbFPstream qbstdout(1);
    return qbstdout;
}
InputStreamBase& GET_STDIN()
{
    static QbFIstream qbstdin(0);
    return qbstdin;
}
